#include "my_usart.h"

void USARTInit(uint16_t ubrr_value)
{
   UBRRL = ubrr_value;
   UBRRH = (ubrr_value>>8);
   //UCSRC=(1<<URSEL)|(3<<UCSZ0);
   //UCSRB=(1<<RXEN)|(1<<TXEN);
   
   UCSRB |= (1 << RXEN ) |(1<<TXEN) ; // Turn on the transmission and reception circuitry
   UCSRC |= (1 << URSEL ) | (1 << UCSZ0 ) | (1 << UCSZ1 ); // Use 8- bit character sizes
   
   //UCSRB = (1<<TXEN) | (1<<RXEN) | (1<<RXCIE);
   UCSRB |= (1 << RXCIE );
   //UCSRB = (1 << RXCIE );
   //UCSRC = 1<<URSEL | 1<<UCSZ1 | 1<<UCSZ0 ;
   sei ();
}



char USARTReadChar()
{
  while(!(UCSRA & (1<<RXC)))
   {
      //Do nothing
   }
   return UDR;
}


void USARTWriteChar(char data)
{
   while(!(UCSRA & (1<<UDRE)))
   {
      //Do nothing
   }
  UDR=data;
  
  while (!(UCSRA & (1<<TXC)))
  {
  }
}